#!/usr/bin/perl

# Determin operating system
$Os = $^O;

if($Os == "MSWin32"){
	use Win32::SerialPort;
}else{
	print "Only Win32 Operating Systems supported at this time";
}

if(scalar(@ARGV) < 2){
	print "Usage: gpioread.pl <PORT> <RELAYNUM>\nEg: gpioread.pl COM1 0";
	exit; 
}

$portName = $ARGV[0];
$gpioNum = $ARGV[1];

$serPort = new Win32::SerialPort($portName, quiet)
		   || die "Could not open the port specified";
		   
$serPort->baudrate(19200);
$serPort->parity("none");
$serPort->databits(8);
$serPort->stopbits(1);
$serPort->handshake("none");
$serPort->buffers(4096, 4096); 
$serPort->read_interval(100);   
$serPort->read_char_time(5);  
$serPort->read_const_time(100); 
$serPort->write_char_time(5);
$serPort->write_const_time(100);
$serPort->lookclear();

$serPort->write("gpio read $gpioNum\n\r");
($count, $data) = $serPort->read(25);

$substring = substr $data, $count - 4, 1 ;

if($substring == "1"){
	print "GPIO $gpioNum is ON\n";
}

if($substring == "0"){
	print "GPIO $gpioNum is OFF\n";
}
		   
$serPort->close();
		   
