#!/usr/bin/perl

# Determin operating system
$Os = $^O;

if($Os == "MSWin32"){
	use Win32::SerialPort;
}else{
	print "Only Win32 Operating Systems supported at this time";
}

if(scalar(@ARGV) < 2){
	print "Usage: relayread.pl <PORT> <RELAYNUM>\nEg: relayread.pl COM1 0";
	exit; 
}

$portName = $ARGV[0];
$relayNum = $ARGV[1];

$serPort = new Win32::SerialPort($portName, quiet)
		   || die "Could not open the port specified";
		   
$serPort->baudrate(19200);
$serPort->parity("none");
$serPort->databits(8);
$serPort->stopbits(1);
$serPort->handshake("none");
$serPort->buffers(4096, 4096); 
$serPort->read_interval(100);   
$serPort->read_char_time(5);  
$serPort->read_const_time(100); 
$serPort->write_char_time(5);
$serPort->write_const_time(100);
$serPort->lookclear();

$serPort->write("relay read $relayNum\n\r");
($count, $data) = $serPort->read(25);

if($data =~ /on/){
	print "Relay $relayNum is ON\n";
}

if($data =~ /off/){
	print "Relay $relayNum is OFF\n";
}
		   
$serPort->close();
		   
